---
title: Atomics.xor()
slug: Web/JavaScript/Reference/Global_Objects/Atomics/xor
tags:
  - Atomics
  - JavaScript
  - Method
  - Shared Memory
---
<div>{{JSRef}}</div>

<p>The static <code><strong>Atomics</strong></code><strong><code>.xor()</code></strong> method computes a bitwise XOR with a given value at a given position in the array, and returns the old value at that position. This atomic operation guarantees that no other write happens until the modified value is written back.</p>

<div>{{EmbedInteractiveExample("pages/js/atomics-xor.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Atomics.xor(typedArray, index, value)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>typedArray</code></dt>
 <dd>An integer typed array. One of {{jsxref("Int8Array")}}, {{jsxref("Uint8Array")}}, {{jsxref("Int16Array")}}, {{jsxref("Uint16Array")}}, {{jsxref("Int32Array")}}, {{jsxref("Uint32Array")}}, {{jsxref("BigInt64Array")}}, or {{jsxref("BigUint64Array")}}.</dd>
 <dt><code>index</code></dt>
 <dd>The position in the <code>typedArray</code> to compute the bitwise XOR.</dd>
 <dt><code>value</code></dt>
 <dd>The number to compute the bitwise XOR with.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The old value at the given position (<code>typedArray[index]</code>).</p>

<h3 id="Exceptions">Exceptions</h3>

<ul>
 <li>Throws a {{jsxref("TypeError")}}, if <code>typedArray</code> is not one of the allowed integer types.</li>
 <li>Throws a {{jsxref("RangeError")}}, if <code>index</code> is out of bounds in the <code>typedArray</code>.</li>
</ul>

<h2 id="Description">Description</h2>

<p>The bitwise XOR operation yields 1, if <code>a</code> and <code>b</code> are different. The truth table for the XOR operation is:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th><code>a</code></th>
   <th><code>b</code></th>
   <th><code>a ^ b</code></th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>0</td>
   <td>0</td>
   <td>0</td>
  </tr>
  <tr>
   <td>0</td>
   <td>1</td>
   <td>1</td>
  </tr>
  <tr>
   <td>1</td>
   <td>0</td>
   <td>1</td>
  </tr>
  <tr>
   <td>1</td>
   <td>1</td>
   <td>0</td>
  </tr>
 </tbody>
</table>

<p>For example, a bitwise XOR of <code>5 ^ 1</code> results in <code>0100</code> which is 4 in decimal.</p>

<pre class="notranslate">5  0101
1  0001
   ----
4  0100
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Using_xor">Using xor</h3>

<pre class="brush: js notranslate">const sab = new SharedArrayBuffer(1024);
const ta = new Uint8Array(sab);
ta[0] = 5;

Atomics.xor(ta, 0, 1); // returns 5, the old value
Atomics.load(ta, 0);  // 4</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-atomics.xor', 'Atomics.xor')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Atomics.xor")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Atomics")}}</li>
 <li>{{jsxref("Atomics.and()")}}</li>
 <li>{{jsxref("Atomics.or()")}}</li>
</ul>
